/**
 * Created by Aleksey Chichenkov <a.chichenkov@initi.ru> on 1/28/19.
 */

var js_beautify = require("js-beautify");
var args = require("args-parser")(process.argv);
var fs = require("fs");
var exec = require('child_process').exec;

var config;
if(args["c"] !== undefined) {
    config = require("./" + args["c"]);
} else {
    config = require("./config.js");
}

var program_path = config.lemon_bin;
var lemon_flags = config.flags;
var parser_path = config.out_path;
var file_name = config.file_name;

var fn_y = file_name + ".y";
var fn_js = file_name + ".js";
var fn_out = file_name + ".out";

var temp_fn_y = "temp_" + "file_name" + ".y";
var temp_fn_js = "temp_" + "file_name" + ".js";
var temp_fn_out = "temp_" + "file_name" + ".out";


var update_parser_y = function () {
    var source_parser_y = fs.readFileSync(parser_path + fn_y, "utf8");

    var result = /&&.*?REPLACER\{(.*?)\}&&/gm.exec(source_parser_y);
    if(result) {
        var file_path = result[1];
        var process_code = fs.readFileSync(file_path, "utf8");

        source_parser_y = source_parser_y.replace(/&&.*?REPLACER\{(.*?)\}&&/gm, process_code);

        fs.writeFileSync(parser_path + temp_fn_y, source_parser_y);
    }
};

var post_process_parser = function () {
    var out_js = fs.readFileSync(parser_path + temp_fn_js, "utf8");

    if(args["t"] !== undefined) {
        switch (args["t"]) {
            case "web":
                out_js = "(function(){\n" + out_js + "return Lexer; \n})()";
                break;
            case "node":
                out_js += "\n\n module.exports = LemonJS;";
                break;
        }
    }

    out_js = js_beautify(out_js, {indent_size: 4, space_in_empty_paren: true});

    fs.writeFileSync(parser_path + fn_js, out_js);

    var temp_parser_out = fs.readFileSync(parser_path + temp_fn_out, "utf8");
    fs.writeFileSync(parser_path + fn_out, temp_parser_out);
};

var start = function () {
    update_parser_y();

    exec(program_path + " " + parser_path + temp_fn_y + " " + lemon_flags, function(err, stdout, stderr) {
        err && console.log("ERROR: ", err);
        err && process.exit(1);

        post_process_parser();

        fs.unlinkSync(parser_path + temp_fn_y);
        fs.unlinkSync(parser_path + temp_fn_js);
        fs.unlinkSync(parser_path + temp_fn_out);
    });
};

start();